// Copyright (c) 2006,2007 Polybus Systems Corp., Westford, MA, USA 
// All rights reserved 

// Redistribution and use in source and binary forms, with or without 
// modification, are permitted provided that the following conditions 
// are met: 

// 1. Redistributions of source code must retain the above copyright 
// notice, this list of conditions and the following disclaimer. 

// 2. Redistributions in binary form must reproduce the above copyright 
// notice, this list of conditions and the following disclaimer in the 
// documentation and/or other materials provided with the distribution. 

// 3. All advertising materials mentioning features or use of this software 
// must display the following acknowledgement: 
// This product includes software developed by the Polybus Systems Corporation. 

// 4. Neither the name of Polybus System Corporation or the names of its contributors 
// may be used to endorse or promote products derived from this software 
// without specific prior written permission. 

// THIS SOFTWARE IS PROVIDED BY POLYBUS SYSTEMS CORP AND IT'S CONTRIBUTORS "AS IS" AND 
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
// ARE DISCLAIMED. IN NO EVENT SHALL THE POLYBUS SYSTEMS CORP OR CONTRIBUTORS BE LIABLE 
// FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
// DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS 
// OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
// HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
// LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
// OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF 
// SUCH DAMAGE. 

#include "sys_basher.h"

void mySysInfo(my_sysinfo *sys_info)
{
  FILE *file=0;
  char buffer[0x10000],*indx=0,param[256];
  SInt64 value;
  sys_info->totalram = 0;
  sys_info->freeram = 0;
  sys_info->totalswap = 0;
  sys_info->freeswap = 0;
  sys_info->bufferram = 0;
  sys_info->sharedram = 0;
  sys_info->mem_unit = 1;
  file = fopen ("/proc/meminfo", "r");
  if(file != NULL)
    {
      fread(buffer,sizeof(char),0x8000,file);
      fclose(file);
      indx = buffer;
      buffer[0xFFFF] = 0;
      while(getSysInfo(&indx,param,&value))
	{
	  downCaseString(param);
	  if(0 == strcmp(param,"memtotal"))
	    {
	      sys_info->totalram = value;
	    }
	  else if(0 == strcmp(param,"memfree"))
	    {
	      sys_info->freeram= value;
	    }
	  else if(0 == strcmp(param,"swaptotal"))
	    {
	      sys_info->totalswap= value;
	    }
	  else if(0 == strcmp(param,"swapfree"))
	    {
	      sys_info->freeswap= value;
	    }
	  else if(0 == strcmp(param,"buffers"))
	    {
	      sys_info->bufferram= value;
	    }
	}
	    
    }
}
